routes/web.php
<?php

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Route::get('/', function () {
    return view('welcome');
})->name('home');

Route::resource('contactos', 'ContactoController');

app/Contactos.php
<?php

namespace App;

use Illuminate\Database\Eloquent\Model;

class Contactos extends Model
{
    protected $fillable = ['nombre', 'email', 'fecha_nacimiento', 'genero'];
}

app/Http/Controllers/ContactoController.php
<?php

namespace App\Http\Controllers;

use App\Contactos;
use App\Http\Requests\FormContacto;
use Illuminate\Http\Request;

class ContactoController extends Controller
{
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {
        $contactos = Contactos::paginate(10);

        return view('contactos.index')->with('contactos', $contactos);
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        return view('contactos.create');
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(FormContacto $request)
    {
        $validateData = $request->validated();

        $contacto = new Contactos($validateData);
        $contacto->save();

        return redirect()->route('contactos.index')->with('success', 'Se ha añadido el contacto correctamente');
    }

    /**
     * Display the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function show($id)
    {
        //
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function edit($id)
    {
        $contacto = Contactos::findOrFail($id);
        return view('contactos.edit')->with('contacto', $contacto);
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function update(FormContacto $request, $id)
    {

        $validateData = $request->validated();

        $contacto = Contactos::findOrFail($id);
        $contacto->update($validateData);

        return redirect()->route('contactos.index')->with('success', 'Se ha modificado el contacto correctamente');
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function destroy($id)
    {
        $contacto = Contactos::findOrFail($id);
        $contacto->delete();

        return redirect()->route('contactos.index')->with('success', 'Se ha eliminado el contacto correctamente');
    }
}

app/Http/Controllers/Controller.php
<?php

namespace App\Http\Controllers;

use Illuminate\Foundation\Bus\DispatchesJobs;
use Illuminate\Routing\Controller as BaseController;
use Illuminate\Foundation\Validation\ValidatesRequests;
use Illuminate\Foundation\Auth\Access\AuthorizesRequests;

class Controller extends BaseController
{
    use AuthorizesRequests, DispatchesJobs, ValidatesRequests;
}

resources/views/contactos/create.blade.php
@extends('layout.default')

@section('content')
    <div class="card">
        <div class="card-header">Añadir Contacto</div>
        <div class="card-body">

            @if ($errors->any())
                <div class="alert alert-danger">
                    <ul>
                        @foreach ($errors->all() as $error)
                            <li>{{ $error }}</li>
                        @endforeach
                    </ul>
                </div>
            @endif

            <form method="POST" action="{{route('contactos.store')}}">
                @csrf

                <div class="form-group">
                    <label for="nombre">Nombre:</label>
                    <input type="text" class="form-control" name="nombre">
                </div>

                <div class="form-group">
                    <label for="email">Email:</label>
                    <input type="text" class="form-control" name="email"/>
                </div>

                <div class="form-group">
                    <label for="fecha_nacimiento">Fecha Nacimiento:</label>
                    <input type="date" class="form-control" name="fecha_nacimiento" max="{{date('Y-m-d')}}">
                </div>

                <div class="form-group">
                    <label for="genero">Genero:</label>
                    <select class="form-control" name="genero">
                        <option> </option>
                        <option value="Hombre">Hombre</option>
                        <option value="Mujer">Mujer</option>
                    </select>
                </div>

                <a href="{{route('contactos.index')}}" class="btn btn-danger">Atras</a>
                <button type="submit" class="btn btn-primary">Añadir Contacto</button>
            </form>
        </div>
    </div>
@endsection

resources/views/contactos/edit.blade.php
@extends('layout.default')

@section('content')
    <div class="card">
        <div class="card-header">Actualizar Contacto</div>
        <div class="card-body">

            @if ($errors->any())
                <div class="alert alert-danger">
                    <ul>
                        @foreach ($errors->all() as $error)
                            <li>{{ $error }}</li>
                        @endforeach
                    </ul>
                </div>
            @endif

            <form method="POST" action="{{route('contactos.update', $contacto->id)}}">
                @csrf
                @method('PATCH')

                <div class="form-group">
                    <label for="nombre">Nombre:</label>
                    <input type="text" class="form-control" name="nombre" value="{{$contacto->nombre}}">
                </div>

                <div class="form-group">
                    <label for="email">Email:</label>
                    <input type="text" class="form-control" name="email" value="{{$contacto->email}}">
                </div>

                <div class="form-group">
                    <label for="fecha_nacimiento">Fecha Nacimiento:</label>
                    <input type="date" class="form-control" name="fecha_nacimiento" max="{{date('Y-m-d')}}" value="{{ date('Y-m-d', strtotime($contacto->fecha_nacimiento)) }}">
                </div>

                <div class="form-group">
                    <label for="genero">Genero:</label>
                    <select class="form-control" name="genero">
                        <option value="Hombre" @if($contacto->genero=="Hombre") selected='selected' @endif> Hombre </option>
                        <option value="Mujer" @if($contacto->genero=='Mujer') selected='selected' @endif> Mujer </option>
                    </select>
                </div>

                <a href="{{route('contactos.index')}}" class="btn btn-danger">Atras</a>
                <button type="submit" class="btn btn-primary">Actualizar Contacto</button>
            </form>
        </div>
    </div>
@endsection

resources/views/contactos/index.blade.php
@extends('layout.default')

@section('content')

        <div class="float-right">
            <a href="{{route('contactos.create')}}" class="btn btn-primary">Añadir</a>
        </div>
        <h1 style="font-size: 2.2rem">Lista de Contactos</h1>
        <hr/>

        @if(session()->get('success'))
            <div class="alert alert-success">
                {{ session()->get('success') }}
            </div><br />
        @endif

        <table class="table table-bordered bg-light">
            <thead class="bg-dark" style="color: white">
            <tr>
                <th width="60px" style="text-align: center">ID</th>
                <th>Nombre</th>
                <th>Email</th>
                <th>Fecha Nacimiento</th>
                <th>Genero</th>
                <th width="150px">Accion</th>
            </tr>
            </thead>
            <tbody>
            @foreach($contactos as $contacto)
                <tr>
                    <th style="text-align: center">{{$contacto->id}}</th>
                    <td>{{$contacto->nombre}}</td>
                    <td>{{$contacto->email}}</td>
                    <td>{{ date('d - M - y', strtotime($contacto->fecha_nacimiento)) }}</td>
                    <td>{{$contacto->genero}}</td>
                    <td align="center">
                        <a class="btn btn-primary btn-sm float-left" title="Edit" href="{{route('contactos.edit',$contacto->id)}}"> Editar </a>

                        <form action="{{ route('contactos.destroy', $contacto->id)}}" method="post">
                            @csrf
                            @method('DELETE')
                            <button class="btn btn-danger btn-sm float-left" type="submit">Eliminar</button>
                        </form>
                    </td>
                </tr>
            @endforeach
            </tbody>
        </table>
        <nav>
            <ul class="pagination justify-content-end">
                {{$contactos->links()}}
            </ul>
        </nav>
@endsection

resources/views/layout/default.blade.php
<!DOCTYPE html>
<html lang="{{ str_replace('_', '-', app()->getLocale()) }}">
<head>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1">

    <title>Contactos</title>

    <link href="https://fonts.googleapis.com/css?family=Nunito:200,600" rel="stylesheet">
    <link rel="stylesheet" type="text/css" href="{{asset('css/app.css')}}">
    @yield('css')
</head>
<body>
    <div class="container mt-5">
        @yield('content')
    </div>

    <script src="{{asset('js/app.js')}}"></script>
    @yield('js')
</body>
</html>